<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 31/03/2015
 * Time: 16:01
 */

namespace Service\OAuth;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Events\PreDispatch\Listener;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\Session\Session;

class RequestListenerOAuth extends Listener {

    const OAUTH_HEADER = "OAuth-Token";
    const OAUTH_SECRET_ID = "OAuth-SecretId";

    private $httpKernel;
    private $oauth;
    private $sessionManager;
    private $publicRoutes;

    public function __construct(Kernel $kernel, OAuthCustomImpl $oauth, Session $sessionManager){
        $this->httpKernel = $kernel;
        $this->oauth = $oauth;
        $this->sessionManager = $sessionManager;
        $this->publicRoutes = $this->readPublicRoutes();
    }

    private function readPublicRoutes(){
        $urls = file_get_contents("./json/publicRoutes.json");
        return json_decode($urls, true);
    }

    public function preDispatch(Request $request) {
        try {
            $token = $this->httpKernel->getHttpRequest()->getHeaders()->get(self::OAUTH_HEADER);
            if (!is_null($token)) {
                $secretId = $this->httpKernel->getHttpRequest()->getHeaders()->get(self::OAUTH_SECRET_ID);
                $service = $this->oauth->checkAccess($token, $secretId);
                $this->sessionManager->set("NRORG", $service->getNrOrg());
                $this->sessionManager->set("NRORGTRAB", $service->getNrOrg());
                $this->sessionManager->set("NRORGPADRAO", 0);
            }

            if (!in_array($request->getRoutePath(), $this->publicRoutes) && !$this->sessionManager->has("NRORG")) {
                throw new \Exception("Access denied.");
            }
        }catch (\Exception $e){
            throw new \Exception($e->getMessage());
        }
    }
}